/********************************************************************************
 * Copyright (c) 2018-2024 Bayerische Motoren Werke Aktiengesellschaft (BMW AG)
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 ********************************************************************************/
#include "DriverCharacteristicsSampler.h"

#include <algorithm>
#include <cmath>
#include <string>
#include <vector>

#include "../../../src/Logging/Logging.h"
#include "DriverCharacteristics.h"
#include "StochasticData.h"

DriverCharacteristicsSampler::DriverCharacteristicsSampler(StochasticsInterface* stochasticsI)
{
  stochastics = stochasticsI;
}

DriverCharacteristicsSampler::~DriverCharacteristicsSampler()
{
}

std::unique_ptr<DriverCharacteristics> DriverCharacteristicsSampler::SampleDriverCharacteristics()
{
  sampleIDs.clear();
  sampleNames.clear();
  sampleValues.clear();

  // This is currently not used but later sampling after finxing a whole collumn can be implemented
  const std::vector<std::string> levels = {"measurable variables",
                                           "latent-exogenous variables",
                                           "latent-endogenous variables",
                                           "measurable variables"};

  StochasticData stochasticData;
  DiscreteDistributionInformation test = stochasticData.dist2;

  // TODO: this should be generated by the Matlab script and being moved into to StocasticData.h file.
  // This is the first data which has to be adapted when the sampling graph changes (new connections or variables).
  // The second part to be changed is at the end of the function where argument values are searched by their name.
  // TODO: currently there is no need for implementing diffrent layers. the model would work linearized, too.
  // But later sampling after fixing a collumn can be implemented and then collumn information is needed.
  static const std::vector<std::vector<DiscreteDistributionInformation>> levelVariables = {
      {stochasticData.dist2, stochasticData.dist3, stochasticData.dist4},
      {stochasticData.dist5, stochasticData.dist6, stochasticData.dist7, stochasticData.dist8, stochasticData.dist9, stochasticData.dist10},
      {stochasticData.dist11, stochasticData.dist12, stochasticData.dist13, stochasticData.dist14, stochasticData.dist15, stochasticData.dist16, stochasticData.dist17, stochasticData.dist18, stochasticData.dist19, stochasticData.dist20, stochasticData.dist21}};

  // Test if header file is correctly created by Matlab
  bool is1D = true;
  for (const auto& var : levelVariables.at(0))
  {
    if (var.dims != 1)
    {
      is1D = false;
    }
  }

  // TODO: Here a runtime error has to be thrown like in the StochasticsImplementataion methods
  if (!is1D)
  {
    const std::string msg = COMPONENTNAME + " first layer of stochastic variables has to be 1D";
    Logging::Error(msg);

    return nullptr;
  }

  /************************
   * LOOP over 1.1 and 1.2 *
   ************************/
  for (int i = 0; i < (int)levelVariables.size(); ++i)
  {
    for (const DiscreteDistributionInformation& var : levelVariables.at(i))
    {
      sampleIDs.push_back(var.dimIDs.back());
      sampleNames.push_back(var.dimNames.back());

      // variable doesn’t depend on another variable
      if (var.dims == 1)
      {
        double sampledValue = stochastics->SampleFromDiscreteDistribution(&var);
        sampleValues.push_back(sampledValue);
        continue;
      }

      /*************************************************************************
       * 1.1. Condition all 2nd column variables on 1st column variables:       *
       * For example fear would be conditioned on age. Variables that do        *
       * not depend on 1st column variables like Thrill Seeking remain.         *
       * As a result only 1D fields should be left for all 2nd column variables *
       *************************************************************************/
      // create conditions vector
      std::vector<double> conditions;
      for (int j = 0; j < (var.dims - 1); ++j)
      {
        // values from variables sampeled before is stored in sampleNames and sampleValues
        conditions.push_back(getSampeledValueByID(var.dimIDs.at(j)));
      }
      conditions.push_back(NAN);

      /*********************************************************
       * 1.2. Sample values from all 2nd column variables:      *
       * For example draw values from fear, risk and experience *
       * seeking. Store those values for visualization.          *
       *********************************************************/
      struct DiscreteDistributionInformation* conditionedVariable =
          stochastics->ConditionOnRandomVariables(&var, conditions, var.dims - 1);
      double sampledValue = stochastics->SampleFromDiscreteDistribution(conditionedVariable);
      sampleValues.push_back(sampledValue);
      delete conditionedVariable;
    }  // end for specific stochastic variable
  }    // end for stochastic variable type

  /*****************************************************************
   * 3. Return all sampled values including hard coded parameters: *
   * Create DriverParameterSignal object and fill it with data.     *
   *****************************************************************/

  std::unique_ptr<DriverCharacteristics> ret = std::make_unique<DriverCharacteristics>(DriverCharacteristics());
  // TODO: unabhaenig von genauem Matlab variablen namen?
  ret->gender = round(getSampeledValueByName("Gender"));  // round to 0 or 1 (male or female)
  ret->age = getSampeledValueByName("Age");
  ret->drivingRoutine = getSampeledValueByName("Driving Routine");

  ret->patience = getSampeledValueByName("Patience");
  ret->riskTolerance = getSampeledValueByName("Risk Tolerance");
  ret->anxiety = getSampeledValueByName("Anxiety");
  ret->disinhibition = getSampeledValueByName("Disinhibition");
  ret->thrillSeeking = getSampeledValueByName("Thrill Seeking");
  ret->boredomSusceptibility = getSampeledValueByName("Boredom Susceptibility");

  ret->drivingDynamics = NAN;
  ret->safetyNeed = NAN;
  ret->driverPerformance = NAN;

  ret->vWish = units::make_unit<units::velocity::meters_per_second_t>(getSampeledValueByName("v wish") / 3.6);                              // in matlab this is calculated in km/h
  ret->deltaVViolation = units::make_unit<units::velocity::meters_per_second_t>(getSampeledValueByName("median delta v violation") / 3.6);  // in matlab this is calculated in km/h
  ret->tgapego = units::make_unit<units::time::second_t>(getSampeledValueByName("median THW A0"));
  ret->outerKeepingIntensity = getSampeledValueByName("percent right A0");
  ret->comfortLongitudinalAcceleration = units::make_unit<units::acceleration::meters_per_second_squared_t>(getSampeledValueByName("mean aeigen komfort A0 120"));
  ret->comfortLongitudinalDeceleration = units::make_unit<units::acceleration::meters_per_second_squared_t>(getSampeledValueByName("mean verz komfort A0 120"));
  ret->comfortLateralAcceleration = units::make_unit<units::acceleration::meters_per_second_squared_t>(getSampeledValueByName("mean aquer komfort A0"));
  ret->qualityLaneKeeping = getSampeledValueByName("qualitaet Spur haltung A0");
  ret->stearingAngle = units::make_unit<units::angular_velocity::radians_per_second_t>(getSampeledValueByName("mean Lenk w komfort A0"));
  ret->desiredTimeAtTargetSpeed = units::make_unit<units::time::second_t>(getSampeledValueByName("t SPWE langsam A0"));
  ret->reactionBaseTime = units::make_unit<units::time::second_t>(getSampeledValueByName("t reaction min A1 Stau"));

  return ret;
}

inline double DriverCharacteristicsSampler::getSampeledValueByName(std::string name)
{
  int pos = std::distance(sampleNames.begin(),
                          std::find(sampleNames.begin(), sampleNames.end(), name));
  return sampleValues.at(pos);
}

inline double DriverCharacteristicsSampler::getSampeledValueByID(int id)
{
  int pos = std::distance(sampleIDs.begin(),
                          std::find(sampleIDs.begin(), sampleIDs.end(), id));
  return sampleValues.at(pos);
}
